<%-- src_input_text tag --%>
<%@ tag pageEncoding="UTF-8" body-content="empty"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%@ taglib uri="http://www.jasminesoft.co.jp/jfc" prefix="jfc" %>
<%@ taglib tagdir="/WEB-INF/tags" prefix="tags" %>
<fmt:setBundle basename="jfcapp"/>

<%@ attribute name="value" required="true" type="java.lang.Object" %> <%-- ${TemplateModel_p.FDate} --%>
<%@ attribute name="name" required="true" %> <%-- TemplateModel_p_002ff_date --%>
<%@ attribute name="isOutputFieldClass" type="java.lang.Boolean" %>
<%@ attribute name="fieldClassSuffix" %>
<%@ attribute name="type" required="true" %>
<%@ attribute name="size" %>
<%@ attribute name="bytesize" %>
<%@ attribute name="maxlength" %>
<%@ attribute name="autocomplete" %>
<%@ attribute name="isReadonly" type="java.lang.Boolean" %>
<%@ attribute name="onchange" %>
<%@ attribute name="onblur" %>
<%@ attribute name="imeMode" %>
<%@ attribute name="enterKeyAction" %>
<%@ attribute name="isNormalizeDate" type="java.lang.Boolean" %>
<%@ attribute name="dateformat" %>
<%@ attribute name="numberformat" %>
<%@ attribute name="style" %>
<%@ attribute name="isSmartPhone" type="java.lang.Boolean" %>
<%@ attribute name="tooltip" %>
<%@ attribute name="placeholder" %>
<%@ attribute name="cursorPosition" %>
<%@ attribute name="isCalendarinput" %>
<%@ attribute name="calendarinputButtonType" %>
<%@ attribute name="isRequired" type="java.lang.Boolean" %>
<%@ attribute name="constraints" %>
<%@ attribute name="regExp" %>
<%@ attribute name="tabIndex" %>

<%-- __class variable --%>
<c:set var="__class" value=""/>
<c:choose>
<c:when test="${isOutputFieldClass}">
  <c:choose>
  <c:when test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield${fieldClassSuffix}"/>
  </c:when>
  <c:otherwise>
    <c:set var="__class" value="field${fieldClassSuffix}"/>
  </c:otherwise>
  </c:choose>
</c:when>
<c:otherwise>
  <c:if test="${fn:length(value.errorcode) > 0}">
    <c:set var="__class" value="errorfield_nowidth"/>
  </c:if>
</c:otherwise>
</c:choose>

<c:set var="__style" value=""/>
<c:if test="${fn:length(style) > 0}">
  <c:set var="__style" value="${style}"/>
</c:if>
<c:set var="_dojoType" value="data-dojo-type=\"wagby/TextBox\""/>

<%-- _type variable --%>
<c:set var="_type" value=""/>
<c:choose>
<c:when test="${type == 'url' && !isSmartPhone}">
  <c:set var="_type" value="text"/>
</c:when>
<c:when test="${type == 'email' && !isSmartPhone}">
  <c:set var="_type" value="text"/>
</c:when>
<c:when test="${type == 'password:hide'}">
  <c:set var="_type" value="password"/>
</c:when>
<c:when test="${isCalendarinput}">
  <c:set var="_type" value="text"/>
  <c:set var="_dojoType" value="data-dojo-type=\"wagby/DateTextBox\""/>
  <c:set var="jfcCalendarFirstDayOfWeek" value="0"/>
  <c:if test="${fn:length(__jfc_calendarFirstDayOfWeek) > 0}">
    <c:set var="jfcCalendarFirstDayOfWeek" value="${__jfc_calendarFirstDayOfWeek}"/>
  </c:if>
</c:when>
<c:when test="${type == 'number'}">
  <c:set var="_dojoType" value="data-dojo-type=\"wagby/NumberTextBox\""/>
  <c:set var="_pattern" value="####"/>
  <c:if test="${numberformat != ''}">
    <c:choose>
    <c:when test="${fn:contains(numberformat, '\\\\')}">
      <c:set var="__numberformat" value="${fn:substring(numberformat, 1, fn:length(numberformat))}"/>
      <c:set var="_pattern" value="&yen;${__numberformat}"/>
    </c:when>
    <c:otherwise>
      <c:set var="_pattern" value="${numberformat}"/>
    </c:otherwise>
    </c:choose>
  </c:if>
  <c:choose>
    <c:when test="${fn:length(constraints) > 0}">
      <c:set var="constraints" value="pattern:'${_pattern}',${constraints}"/>
    </c:when>
    <c:otherwise>
      <c:set var="constraints">pattern:'${_pattern}'</c:set>
    </c:otherwise>
  </c:choose>
</c:when>
<c:otherwise>
  <c:set var="_type" value="${type}"/>
</c:otherwise>
</c:choose>

<%-- onblur variable --%>
<c:if test="${type != 'hidden'}">
  <c:if test="${isNormalizeDate}">
    <c:set var="_onblur">normalizeDate(this);</c:set>
  </c:if>
  <c:set var="onblur">${_onblur}${onblur}</c:set>
</c:if>

<%-- onfocus variable --%>
<c:set var="onfocus">setScrollPosition(this.id);${onfocus}</c:set>
<%-- onkeydown variable --%>
<c:choose>
<c:when test="${enterKeyAction == 'changetab'}">
<c:set var="onkeydown" value="if (event.keyCode !== 0x0d) return; enterKeyHandler.focusNextElement(this, event);"/>
</c:when>
<c:when test="${enterKeyAction == 'ignore'}">
<c:set var="onkeydown" value="if (event.keyCode !== 0x0d) return; event.preventDefault();"/>
</c:when>
<c:when test="${enterKeyAction == 'default'}">
<c:set var="onkeydown" value="if (event.keyCode !== 0x0d) return; doSubmitForm(event.srcElement.form);"/>
</c:when>
<c:otherwise>
<c:set var="onkeydown" value="${enterKeyAction}"/>
</c:otherwise>
</c:choose>

<%-- numberformat variable --%>
<c:set var="__displayedValue" value="${value.content}"/>
<c:set var="__nonescapeDisplayedValue" value=""/>
<c:if test="${fn:length(numberformat) > 0}">
<c:catch var="exception">
  <c:choose>
  <c:when test="${fn:contains(numberformat, '\\\\')}">
    <fmt:formatNumber value="${value.content < 0. ? -value.content : value.content}" pattern="${__numberformat}" var="__displayedValue"/>
    <c:choose>
    <c:when test="${fn:length(value.content) > 0}">
      <c:choose>
      <c:when test="${value.content > 0.}">
        <c:set var="__nonescapeDisplayedValue" value="&yen;"/>
	  </c:when>
      <c:otherwise>
        <c:set var="__nonescapeDisplayedValue" value="-&yen;"/>
      </c:otherwise>
      </c:choose>
    </c:when>
    <c:otherwise>
      <c:set var="__nonescapeDisplayedValue" value=""/>
    </c:otherwise>
    </c:choose>
  </c:when>
  <c:otherwise>
    <fmt:formatNumber value="${value.content}" pattern="${numberformat}" var="__displayedValue"/>
  </c:otherwise>
  </c:choose>
</c:catch>
</c:if>

<c:if test="${type != 'file' and !isReadonly}">
<input ${_dojoType} type="${_type}" id="${name}" name="${name}"
<c:choose>
<c:when test="${type == 'password:hide'}"> value=""</c:when>
<c:when test="${type != 'file'}"> value="${fn:escapeXml(__displayedValue)}" </c:when>
</c:choose>
<c:if test="${type != 'hidden'}">
  <c:if test="${fn:length(__class) > 0}"> class="${__class}"</c:if>
  <c:if test="${fn:length(maxlength) > 0}"> maxLength="${maxlength}"</c:if>
  <c:if test="${fn:length(autocomplete) > 0}"> autocomplete="${autocomplete}"</c:if>
  <c:set var="__width" value=""/>
  <c:if test="${fn:length(size) > 0}">
    <c:set var="__width" value="width: ${size}em;"/>
    <c:choose>
      <c:when test="${fn:length(__style) > 0}">
        <c:set var="__style" value="${__style}; ${__width}"/>
      </c:when>
      <c:otherwise>
        <c:set var="__style" value="${__width}"/>
      </c:otherwise>
    </c:choose>
  </c:if>
  <c:if test="${fn:length(__style) > 0}"> style="${__style}"</c:if>
</c:if>
<c:set var="_dojoProps" value=""/>
<c:if test="${fn:length(onchange) > 0}"><c:set var="_dojoProps" value="onChange:function(event){${onchange}}"/></c:if>
<c:if test="${fn:length(onkeydown) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}onKeyDown:function(event){${onkeydown}}"/></c:if>
<c:if test="${fn:length(onblur) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}onBlur:function(){${onblur}}"/></c:if>
<c:if test="${fn:length(onfocus) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}onFocus:function(event){${onfocus}}"/></c:if>
<c:if test="${isCalendarinput || type == 'number'}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}displayedValue:'${__nonescapeDisplayedValue}${fn:escapeXml(fn:escapeXml(__displayedValue))}'"/><c:if test="${jfcCalendarFirstDayOfWeek > 0}"><c:set var="_dojoProps" value="${_dojoProps}, dayOffset:${jfcCalendarFirstDayOfWeek}"/></c:if></c:if>
<c:if test="${fn:length(dateformat) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}dateFormat:'${dateformat}'"/></c:if>
<c:if test="${fn:length(imeMode) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}imeMode: '${imeMode}'"/></c:if>
<c:if test="${fn:length(cursorPosition) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}cursorPosition: '${cursorPosition}'"/></c:if>
<c:if test="${fn:length(bytesize) > 0}"><c:if test="${fn:length(_dojoProps) > 0}"><c:set var="_dojoProps" value="${_dojoProps}, "/></c:if><c:set var="_dojoProps" value="${_dojoProps}bytesize: '${bytesize}'"/></c:if>
<c:if test="${fn:length(_dojoProps) > 0}"> data-dojo-props="${_dojoProps}"</c:if>
<c:if test="${fn:length(tooltip) > 0}"> title="<fmt:message key='${tooltip}'/>"</c:if>
<c:if test="${fn:length(placeholder) > 0}"> placeHolder="<fmt:message key='${placeholder}'/>"</c:if>
<c:if test="${isRequired}"> required="true"</c:if>
<c:if test="${fn:length(constraints) > 0}"> constraints="{${constraints}}"</c:if>
<c:if test="${fn:length(regExp) > 0}"> regExp="${regExp}"</c:if>
<c:if test="${fn:length(tabIndex) > 0}"> tabIndex="${tabIndex}"</c:if>
/> <%-- input --%>
</c:if>
